<?php

namespace Drupal\site_analysis;

use Drupal\site_analysis\Analysis;

class ParagraphAnalysis extends Analysis {

  public function generateParagraphReport(): array {
    $config = $this->configFactory->get('site_analysis.settings');
    $report = [];

    if ($config->get('paragraph_count')) {
      $report['paragraph_count'] = $this->getParagraphCount();
    }

    return $report;
  }

  private function getParagraphCount() {
    $paragraphTypes = \Drupal::entityTypeManager()
      ->getStorage('paragraphs_type')
      ->loadMultiple();

    $count = [];
    foreach ($paragraphTypes as $type) {
      $count[$type->id()] = \Drupal::entityQuery('paragraph')
        ->accessCheck(FALSE)
        ->condition('type', $type->id())
        ->count()
        ->execute();
    }

    return $count;
  }

}
